unit inDMPerformance;

interface

uses
  Windows, ActiveX, ComObj, DirectMusic, DirectSound;


type
  TinDirectMusicPerformance = class(TComObject, IDirectMusicPerformance)
  private
    FDirectMusicPerformance: IDirectMusicPerformance;
  protected
    procedure Initialize; override;
    function Init (var ppDirectMusic: IDirectMusic;
                   pDirectSound: IDirectSound;
                   hWnd: HWND ) : HResult; stdcall;
    function PlaySegment (pSegment: IDirectMusicSegment;
                          dwFlags: DWORD;
                          i64StartTime: LongLong;
                          ppSegmentState: PIDirectMusicSegmentState) : HResult; stdcall;
    function Stop (pSegment: IDirectMusicSegment;
                   pSegmentState: IDirectMusicSegmentState;
                   mtTime: TMusic_Time;
                   dwFlags: DWORD) : HResult; stdcall;
    function GetSegmentState (out ppSegmentState: IDirectMusicSegmentState;
                              mtTime: TMusic_Time) : HResult; stdcall;
    function SetPrepareTime (dwMilliSeconds: DWORD) : HResult; stdcall;
    function GetPrepareTime (out pdwMilliSeconds: DWORD) : HResult; stdcall;
    function SetBumperLength (dwMilliSeconds: DWORD) : HResult; stdcall;
    function GetBumperLength (out pdwMilliSeconds: DWORD) : HResult; stdcall;
    function SendPMsg (out pPMSG: TDMus_PMsg) : HResult; stdcall;
    function MusicToReferenceTime (mtTime: TMusic_Time;
                                   out prtTime: TReference_Time) : HResult; stdcall;
    function ReferenceToMusicTime (rtTime: TReference_Time;
                                   out pmtTime: TMusic_Time) : HResult; stdcall;
    function IsPlaying (pSegment: IDirectMusicSegment;
                        pSegState: IDirectMusicSegmentState) : HResult; stdcall;
    function GetTime (prtNow: PReference_Time;
                      pmtNow: PMusic_Time) : HResult; stdcall;
    function AllocPMsg (cb: ULONG;
                        out ppPMSG: PDMus_PMsg) : HResult; stdcall;
    function FreePMsg (pPMSG: PDMus_PMsg) : HResult; stdcall;
    function GetGraph (out ppGraph: IDirectMusicGraph) : HResult; stdcall;
    function SetGraph (pGraph: IDirectMusicGraph) : HResult; stdcall;
    function SetNotificationHandle (hNotification: THANDLE;
                                    rtMinimum: TReference_Time) : HResult; stdcall;
    function GetNotificationPMsg (out ppNotificationPMsg: PDMus_Notification_PMsg) : HResult; stdcall;
    function AddNotificationType (const rguidNotificationType: TGUID) : HResult; stdcall;
    function RemoveNotificationType (const rguidNotificationType: TGUID) : HResult; stdcall;
    function AddPort (pPort: IDirectMusicPort) : HResult; stdcall;
    function RemovePort (pPort: IDirectMusicPort) : HResult; stdcall;
    function AssignPChannelBlock (dwBlockNum: DWORD;
                                  pPort: IDirectMusicPort;
                                  dwGroup: DWORD) : HResult; stdcall;
    function AssignPChannel (dwPChannel: DWORD;
                             pPort: IDirectMusicPort;
                             dwGroup, dwMChannel: DWORD) : HResult; stdcall;
    function PChannelInfo (dwPChannel: DWORD;
                           out ppPort: IDirectMusicPort;
                           out pdwGroup, pdwMChannel: DWORD ) : HResult; stdcall;
    function DownloadInstrument (pInst: IDirectMusicInstrument;
                                 dwPChannel: DWORD;
                                 out ppDownInst: IDirectMusicDownloadedInstrument;
                                 var pNoteRanges: TDMus_NoteRange;
                                 dwNumNoteRanges: DWORD;
                                 out ppPort: IDirectMusicPort;
                                 out pdwGroup, pdwMChannel: DWORD) : HResult; stdcall;
    function Invalidate (mtTime: TMusic_Time;
                         dwFlags: DWORD) : HResult; stdcall;
    function GetParam (const rguidType: TGUID;
                       dwGroupBits, dwIndex: DWORD;
                       mtTime:      TMusic_Time;
                       out pmtNext: TMusic_Time;
                       pParam: Pointer) : HResult; stdcall;
    function SetParam (const rguidType: TGUID;
                       dwGroupBits, dwIndex: DWORD;
                       mtTime: TMusic_Time;
                       pParam: Pointer) : HResult; stdcall;
    function GetGlobalParam (const rguidType: TGUID;
                             pParam: Pointer;
                             dwSize: DWORD) : HResult; stdcall;
    function SetGlobalParam (const rguidType: TGUID;
                             pParam: Pointer;
                             dwSize: DWORD) : HResult; stdcall;
    function GetLatencyTime (out prtTime: TReference_Time) : HResult; stdcall;
    function GetQueueTime (out prtTime: TReference_Time) : HResult; stdcall;
    function AdjustTime (rtAmount: TReference_Time) : HResult; stdcall;
    function CloseDown : HResult; stdcall;
    function GetResolvedTime (rtTime: TReference_Time;
                              out prtResolved: TReference_Time;
                              dwTimeResolveFlags: DWORD) : HResult; stdcall;
    function MIDIToMusic (bMIDIValue: BYTE;
                          const pChord: TDMus_Chord_Key;
                          bPlayMode, bChordLevel: Byte;
                          out pwMusicValue: WORD) : HResult; stdcall;
    function MusicToMIDI (wMusicValue: WORD;
                          const pChord: TDMus_Chord_Key;
                          bPlayMode, bChordLevel: BYTE;
                          out pbMIDIValue: BYTE) : HResult; stdcall;
    function TimeToRhythm (mtTime: TMusic_Time;
                           const pTimeSig: TDMus_TimeSignature;
                           out pwMeasure: WORD;
                           out pbBeat, pbGrid: BYTE;
                           out pnOffset: SmallInt) : HResult; stdcall;
    function RhythmToTime (wMeasure: WORD;
                           bBeat, bGrid: BYTE;
                           nOffset: SmallInt;
                           const pTimeSig: TDMus_TimeSignature;
                           out pmtTime: TMusic_Time) : HResult; stdcall;
  end;


var
  Perf: IDirectMusicPerformance;

const
  Class_TinDirectMusicPerformance: TGUID = '{07EBA80C-0E3F-11D4-8B12-706472C10000}';

implementation

uses ComServ;

{ TTinDirectMusic }

function TinDirectMusicPerformance.AddNotificationType(
  const rguidNotificationType: TGUID): HResult;
begin

end;

function TinDirectMusicPerformance.AddPort(
  pPort: IDirectMusicPort): HResult;
begin

end;

function TinDirectMusicPerformance.AdjustTime(
  rtAmount: TReference_Time): HResult;
begin

end;

function TinDirectMusicPerformance.AllocPMsg(cb: ULONG;
  out ppPMSG: PDMus_PMsg): HResult;
begin

end;

function TinDirectMusicPerformance.AssignPChannel(dwPChannel: DWORD;
  pPort: IDirectMusicPort; dwGroup, dwMChannel: DWORD): HResult;
begin

end;

function TinDirectMusicPerformance.AssignPChannelBlock(dwBlockNum: DWORD;
  pPort: IDirectMusicPort; dwGroup: DWORD): HResult;
begin

end;

function TinDirectMusicPerformance.CloseDown: HResult;
begin

end;

function TinDirectMusicPerformance.DownloadInstrument(
  pInst: IDirectMusicInstrument; dwPChannel: DWORD;
  out ppDownInst: IDirectMusicDownloadedInstrument;
  var pNoteRanges: TDMus_NoteRange; dwNumNoteRanges: DWORD;
  out ppPort: IDirectMusicPort; out pdwGroup, pdwMChannel: DWORD): HResult;
begin

end;

function TinDirectMusicPerformance.FreePMsg(pPMSG: PDMus_PMsg): HResult;
begin

end;

function TinDirectMusicPerformance.GetBumperLength(
  out pdwMilliSeconds: DWORD): HResult;
begin

end;

function TinDirectMusicPerformance.GetGlobalParam(const rguidType: TGUID;
  pParam: Pointer; dwSize: DWORD): HResult;
begin

end;

function TinDirectMusicPerformance.GetGraph(
  out ppGraph: IDirectMusicGraph): HResult;
begin

end;

function TinDirectMusicPerformance.GetLatencyTime(
  out prtTime: TReference_Time): HResult;
begin

end;

function TinDirectMusicPerformance.GetNotificationPMsg(
  out ppNotificationPMsg: PDMus_Notification_PMsg): HResult;
begin

end;

function TinDirectMusicPerformance.GetParam(const rguidType: TGUID;
  dwGroupBits, dwIndex: DWORD; mtTime: TMusic_Time;
  out pmtNext: TMusic_Time; pParam: Pointer): HResult;
begin

end;

function TinDirectMusicPerformance.GetPrepareTime(
  out pdwMilliSeconds: DWORD): HResult;
begin

end;

function TinDirectMusicPerformance.GetQueueTime(
  out prtTime: TReference_Time): HResult;
begin

end;

function TinDirectMusicPerformance.GetResolvedTime(rtTime: TReference_Time;
  out prtResolved: TReference_Time; dwTimeResolveFlags: DWORD): HResult;
begin

end;

function TinDirectMusicPerformance.GetSegmentState(
  out ppSegmentState: IDirectMusicSegmentState;
  mtTime: TMusic_Time): HResult;
begin

end;

function TinDirectMusicPerformance.GetTime(prtNow: PReference_Time;
  pmtNow: PMusic_Time): HResult;
begin

end;

function TinDirectMusicPerformance.Init(var ppDirectMusic: IDirectMusic;
  pDirectSound: IDirectSound; hWnd: HWND): HResult;
begin
  MessageBox(0,'Hacked','1',0);
  Result:=FDirectMusicPerformance.Init(ppDirectMusic, pDirectSound, hWnd);
  MessageBox(0,'Hacked','2',0);
end;

procedure TinDirectMusicPerformance.Initialize;
begin
  if Failed(CoCreateInstance(CLSID_DirectMusicPerformance, nil, CLSCTX_INPROC,
    IID_IDirectMusicPerformance, FDirectMusicPerformance)) then
  MessageBox(0,'Hacked','Fail',0);

end;

function TinDirectMusicPerformance.Invalidate(mtTime: TMusic_Time;
  dwFlags: DWORD): HResult;
begin

end;

function TinDirectMusicPerformance.IsPlaying(pSegment: IDirectMusicSegment;
  pSegState: IDirectMusicSegmentState): HResult;
begin

end;

function TinDirectMusicPerformance.MIDIToMusic(bMIDIValue: BYTE;
  const pChord: TDMus_Chord_Key; bPlayMode, bChordLevel: Byte;
  out pwMusicValue: WORD): HResult;
begin

end;

function TinDirectMusicPerformance.MusicToMIDI(wMusicValue: WORD;
  const pChord: TDMus_Chord_Key; bPlayMode, bChordLevel: BYTE;
  out pbMIDIValue: BYTE): HResult;
begin

end;

function TinDirectMusicPerformance.MusicToReferenceTime(
  mtTime: TMusic_Time; out prtTime: TReference_Time): HResult;
begin

end;

function TinDirectMusicPerformance.PChannelInfo(dwPChannel: DWORD;
  out ppPort: IDirectMusicPort; out pdwGroup, pdwMChannel: DWORD): HResult;
begin

end;

function TinDirectMusicPerformance.PlaySegment(
  pSegment: IDirectMusicSegment; dwFlags: DWORD; i64StartTime: LongLong;
  ppSegmentState: PIDirectMusicSegmentState): HResult;
begin

end;

function TinDirectMusicPerformance.ReferenceToMusicTime(
  rtTime: TReference_Time; out pmtTime: TMusic_Time): HResult;
begin

end;

function TinDirectMusicPerformance.RemoveNotificationType(
  const rguidNotificationType: TGUID): HResult;
begin

end;

function TinDirectMusicPerformance.RemovePort(
  pPort: IDirectMusicPort): HResult;
begin

end;

function TinDirectMusicPerformance.RhythmToTime(wMeasure: WORD; bBeat,
  bGrid: BYTE; nOffset: SmallInt; const pTimeSig: TDMus_TimeSignature;
  out pmtTime: TMusic_Time): HResult;
begin

end;

function TinDirectMusicPerformance.SendPMsg(
  out pPMSG: TDMus_PMsg): HResult;
begin

end;

function TinDirectMusicPerformance.SetBumperLength(
  dwMilliSeconds: DWORD): HResult;
begin

end;

function TinDirectMusicPerformance.SetGlobalParam(const rguidType: TGUID;
  pParam: Pointer; dwSize: DWORD): HResult;
begin

end;

function TinDirectMusicPerformance.SetGraph(
  pGraph: IDirectMusicGraph): HResult;
begin

end;

function TinDirectMusicPerformance.SetNotificationHandle(
  hNotification: THANDLE; rtMinimum: TReference_Time): HResult;
begin

end;

function TinDirectMusicPerformance.SetParam(const rguidType: TGUID;
  dwGroupBits, dwIndex: DWORD; mtTime: TMusic_Time;
  pParam: Pointer): HResult;
begin

end;

function TinDirectMusicPerformance.SetPrepareTime(
  dwMilliSeconds: DWORD): HResult;
begin

end;

function TinDirectMusicPerformance.Stop(pSegment: IDirectMusicSegment;
  pSegmentState: IDirectMusicSegmentState; mtTime: TMusic_Time;
  dwFlags: DWORD): HResult;
begin

end;

function TinDirectMusicPerformance.TimeToRhythm(mtTime: TMusic_Time;
  const pTimeSig: TDMus_TimeSignature; out pwMeasure: WORD; out pbBeat,
  pbGrid: BYTE; out pnOffset: SmallInt): HResult;
begin

end;

initialization
  TComObjectFactory.Create(ComServer, TinDirectMusicPerformance, Class_TinDirectMusicPerformance,
    'TinDirectMusicPerformance', '', ciSingleInstance, tmApartment);
end.

